<template>
  <b-sidebar id="discussionsbar" right>
    <h2 v-if="forumTopics.length" class="mt-3 h5 bold mt-5 mr-5">
      The {{ deviceName }}<br />
      <span class="text-orange light italic">Subforum</span>
    </h2>
    <a
      v-if="forumTopics.length"
      class="btn btn-small btn-primary"
      href="https://forums.ubports.com/login"
    >
      Post to UBports forum</a
    >

    <h2 v-if="forumTopics.length" class="small mt-5">
      <a class="d-inline" :href="subforumLink" target="_blank"
        >{{ forumTopics.length }} Forum Discussions
      </a>
    </h2>
    <div v-if="forumTopics.length" class="forum-snippet">
      <ul>
        <li v-for="(topic, index) in forumTopics.slice(0, 8)" :key="index">
          <h3 :class="{ locked: topic.locked != 0, pinned: topic.pinned != 0 }">
            <a :href="topic.link">{{
              topic.title.split(" ").length > 10
                ? topic.title.split(" ").splice(0, 10).join(" ") + " ..."
                : topic.title
            }}</a>
          </h3>
          <p>
            <span class="small">{{
              new Date(topic.timestamp).toLocaleDateString("en-US")
            }}</span>
            •
            <span class="small">{{
              new Date(topic.timestamp).toLocaleTimeString("en-US")
            }}</span>
            • <span class="small">{{ topic.user }}</span> •
            <span class="small">{{ topic.views }} views</span>
          </p>
        </li>
      </ul>
    </div>

    <h2 v-if="communityLinks.length" class="mt-3 h5 bold mt-5 mr-5">
      The {{ deviceName }}<br />
      <span class="text-orange light italic">Community Chat</span>
    </h2>

    <div v-if="communityLinks.length" class="discussions">
      <h3 class="title">Get help</h3>
      <ul>
        <li v-for="link in communityLinks" :key="link.name">
          <a :href="link.link">
            <g-image
              :src="
                require(`!!assets-loader!@/assets/img/services/${link.icon}.svg`)
              "
              alt="link-icon"
              class="dark-invert-40 ext-link-icon"
            />
            {{ link.name }}
          </a>
        </li>
      </ul>
    </div>

    <div v-if="invalidPropCount > 0" class="improve">
      <p class="mt-5">
        <g-link :to="developerReport"
          >Help to improve this page. ({{ invalidPropCount }} missing
          items)</g-link
        >
      </p>
    </div>
  </b-sidebar>
</template>

<script>
import { BSidebar } from "bootstrap-vue";

export default {
  name: "DiscussionsBar",
  components: {
    BSidebar
  },
  props: {
    deviceName: {
      type: String,
      default: ""
    },
    developerReport: {
      type: String,
      default: ""
    },
    invalidPropCount: {
      type: Number,
      default: 0
    },
    communityLinks: {
      type: Array,
      default: function () {
        return [];
      }
    },
    forumTopics: {
      type: Array,
      default: function () {
        return [];
      }
    },
    subforumLink: {
      type: String,
      default: ""
    }
  }
};
</script>
